
package cw.GI;
import cw.log.Log;
import javax.microedition.midlet.*;      
   

import javax.microedition.lcdui.*;
import java.io.InputStream;
 


 class MIDletImageBox extends GIImageBox
//---------------------------
   // holds information regarding an image, like size,
   // and (maybe) size
   {
       
       public Graphics mGraphics;
       public MIDletImageBox(Object pI,int pX,int pY,boolean forWrite)
       {
         super(pI,pX,pY);
         
         if (forWrite)
         {
             mGraphics=((Image)pI).getGraphics();
             MIDletHarness.setFontOnGraphics(mGraphics);
         }
         else
           mGraphics  =null;
       }
       
       public void done()
       {
             mGraphics=null; 
             mImage=null;
       }
   }  



/**
 * this canvas is used by MIDletHarness
 */
class MIDletCanvas extends Canvas
{
    
    MIDletHarness mHarness;
    Image myImage=null;
   
  
    public MIDletCanvas(MIDletHarness pHarness)
    {
      mHarness=pHarness;
    }
  
    protected void paint(Graphics g)
    {
      mHarness.paint(g);
    }
    
    
    protected void keyPressed(int keyCode)
    {
      mHarness.oneKeyPressed(keyCode);
    }
    
    protected void keyReleased(int keyCode)
    {
      mHarness.oneKeyReleased(keyCode);
    } 
    
    public void done()
    {
      mHarness=null;
    }
    
}

/**
 *
 * the GIHarness implementation for MIDlet 1.0 word
 *
 */
public class MIDletHarness extends GIHarness
{
   MIDlet mMIDlet ;
   
   Display mDisplay;     
   MIDletCanvas mCanvas;
   
   
   Graphics mOffScreenGraphics;
   Image mOffScreenImage;
   public boolean mDoubleBuffering=true;
   
   
   public void init(MIDlet pMIDlet)
   {
     //Nog.msg('I',"MIDletHarness.init() started");
      
      
      mMIDlet=pMIDlet;
      mDisplay = Display.getDisplay(mMIDlet);
      mCanvas = new MIDletCanvas(this);
     // mDisplay.setCurrent(mCanvas);
      
      setSize(mCanvas.getWidth(),mCanvas.getHeight());
      
      super.init();
   
      
      if (mDoubleBuffering)
      {
         createImage(mDefaultWriteImage,mMaxX,mMaxY);
         mOffScreenGraphics=((MIDletImageBox)mImages[mDefaultWriteImage]).mGraphics;
         mOffScreenImage=(Image)((MIDletImageBox)mImages[mDefaultWriteImage]).mImage;
         
         setFontOnGraphics(mOffScreenGraphics);
      }
      else
      {
        ;
      }
      
      mFontSizeY=9;
      mFontSizeX=5;
      
      
      // set up key codes
      // todo use upper function.
      
      /*mKeyCodeUp=mCanvas.getKeyCode(Canvas.UP);
      mKeyCodeDown=mCanvas.getKeyCode(Canvas.DOWN);
      mKeyCodeLeft=mCanvas.getKeyCode(Canvas.LEFT);
      mKeyCodeRight=mCanvas.getKeyCode(Canvas.RIGHT);
      mKeyCodeFire=mCanvas.getKeyCode(Canvas.FIRE);
      */
      
      mKeyCodeUp=('2');
      mKeyCodeDown=('8');
      mKeyCodeLeft=('4');
      mKeyCodeRight=('6');
      mKeyCodeFire=mCanvas.getKeyCode(Canvas.RIGHT);
      mKeyCodeUpLeft=('1');
      mKeyCodeUpRight=('3');
      mKeyCodeDownLeft=('7');
      mKeyCodeDownRight=('9');
      
      
      mKeyCodeA=mCanvas.getKeyCode(Canvas.GAME_A);
      mKeyCodeB=mCanvas.getKeyCode(Canvas.GAME_B);
      mKeyCodeC=mCanvas.getKeyCode(Canvas.GAME_C);
      mKeyCodeD=mCanvas.getKeyCode(Canvas.GAME_D);
      
     //Nog.msg('I',"mKeyCodeUp="+mKeyCodeUp);
     //Nog.msg('I',"mKeyCodeDown="+mKeyCodeDown);
     //Nog.msg('I',"mKeyCodeLeft="+mKeyCodeLeft);
     //Nog.msg('I',"mKeyCodeRight="+mKeyCodeRight);
     //Nog.msg('I',"mKeyCodeFire="+mKeyCodeFire);
      
     //Nog.msg('I',"MIDletHarness.init() done");
      
    
      mDisplay.setCurrent(mCanvas);
      
      
   }
   
   
   /* public void postStarted()
    {
      super.postStarted();
      
    }*/
  
    public void done()
    {
      
     
      
      mMIDlet.notifyDestroyed();
      
    
      
      super.done();
       
      mMIDlet=null;
   
      mDisplay=null;     
      mCanvas.done();
      mCanvas=null;
    }
  
 
   //--+ graphics primitives +--------------------------------
  
  
   //--+  create and load images
  
    public GIImageBox loadImageBox(String name,String ext,boolean forWrite) throws Exception
    {
      
      name="/"+name;
      Image pImage;
      MIDletImageBox retVal=null;
      try
      {
         pImage=Image.createImage(name+ext);
      } 
      catch(Exception e)
      {
        pImage=null;
      }
      
      if (pImage!=null)
      {
          retVal=new MIDletImageBox(pImage,pImage.getWidth(),pImage.getHeight(),forWrite);
      }
      
      return retVal;
    } 
    
    
     public GIImageBox createImageBox(int x,int y)
  {
     Image lImage=Image.createImage(x,y);
     if (lImage!=null)
     {
     
       return new MIDletImageBox(lImage,x,y,true);
     }
     else
       return null;
  }
   
  
  //--+  printing
  
    // helper
    public static void setFontOnGraphics(Graphics g)
    {
      g.setFont(Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL)); 
    }
  
 
   // helper
   private Graphics getGraphics(int ofImage)
  {
      Graphics graphics;
      if (ofImage==mDefaultWriteImage && !mDoubleBuffering) graphics=mOffScreenGraphics;
      else graphics=((MIDletImageBox)mImages[ofImage]).mGraphics;
      if (graphics==null) throw new RuntimeException("image "+ofImage+" has no write abilities");
      return graphics;
  }
  
  
  
  
  
  
    public void printImage(int x,int y,int image,int toImage)
    {
    //NL 
    //Nog.msg('D',"printImage() x=",x," y=",y," image=",image," toImage=",toImage);
        Graphics graphics=getGraphics(toImage);
        
        
     // coment for speed test  
       graphics.drawImage((Image)mImages[image].mImage,x,y,
         Graphics.TOP|Graphics.LEFT);
    }
  
  
    public void writeRawTextLine(int x,int y,String text,int color,int toImage)
    {
      
        Graphics graphics=getGraphics(toImage);
        setFontOnGraphics(graphics);
      
        graphics.setColor(color);
  
        graphics.drawString(text,x,y,mOffScreenGraphics.BOTTOM | mOffScreenGraphics.LEFT);
  
    }
    
    
    public void printRect(int x1,int y1,int x2,int y2,int color,boolean filled,int toImage)
    {
        ////Nog.msg('D',"printImage() x1=",x1," y1=",y1," x2=",x2," y2=",y2);
        ////Nog.msg('D'," color=",color," toImage=",toImage);
        Graphics graphics=getGraphics(toImage);
        graphics.setColor(color);
        if (filled)
            graphics.fillRoundRect(x1,y1,x2-x1,y2-y1,0,0);
        else
            graphics.drawRoundRect(x1,y1,x2-x1,y2-y1,0,0);
    }

 
 
    //--+ flow +----------------------------------------------------------------
  
  
    public void requestPaint()
    {
       mCanvas.repaint();
    }
  
   
  
  
    // called by canvas
    public void paint(Graphics g)
    {
      if (!mDoubleBuffering)
      {
        mOffScreenGraphics=g;
        setFontOnGraphics(g);
        paintWrap();
      }
      else
      {
      	mOffScreenGraphics=((MIDletImageBox)mImages[mDefaultWriteImage]).mGraphics;
        
        paintWrap();
        
        //mOffScreenGraphics.drawString("mezzo",20,20,g.TOP | g.LEFT);
        //writeText(20,20,"mezzo",0xFF0000,PLAIN_FONT);
        g.drawImage(mOffScreenImage,0,0,
          Graphics.TOP|Graphics.LEFT);
  
      }
    }
    
    // helper
    public void bufferClear()
    {
        mOffScreenGraphics.setColor(0x00);
        mOffScreenGraphics.fillRoundRect(0,0,mMaxX,mMaxY,0,0);
   
    }
   
}