
package cw.log;

import java.io.*;
import java.util.Date;

public class BasicLogger
{ 
	
   long mStartTime; // holds the system time when log started
   boolean mInitFlag=false; // was the object initialised already
  
  /**
   * like a constructor
   *
   */
  public  void init()
  {
    mInitFlag=true;  
    mStartTime=new Date().getTime();
      
  }
  
  
  /**
   * to log or not to log?
   * @param pLevel
   * @return
   */
  public  boolean doLog(char pLevel)
  {
  	return true;
  }
 
  /**
   * the actual log function. for logging anything but exceptions. 
   */ 
   public  void printMsg(char pLevel,String pMsg)
  {
    if (!mInitFlag) init();
    String msg=getTimeString()+" "+Log.mCnt+" "+"["+pLevel+"] "+getThreadString();
    msg+=":"+pMsg+":";
    System.err.println(msg);
  }
  
  
 /**
  * the actual log function. for logging exceptions
  */ 
  public  void printMsge(char pLevel,String pMsg,Exception p1)
  {
  	printMsg(pLevel,pMsg);
    printMsg(pLevel," exception name="+p1.getClass().getName());
    printMsg(pLevel," exception msg="+p1.getMessage());
    printMsg(pLevel," exception stack=");
    p1.printStackTrace();
  }
  
  
  
 /**
  * @return a current time string
  */ 
  public  String getTimeString()
  {
  	long thisTime=new Date().getTime();
    long deltaTime=thisTime-mStartTime;
    String deltaTimeString=""+deltaTime;
    return deltaTimeString;
    
    
  }
  
  /**
   * The string returned will have a variable length according 
   * to thread id.
   * 
   * @return a thread id string
   */
  public  String getThreadString()
  {
    int tid=Thread.currentThread().hashCode() % 100;
    String tidString="";
    for (int i=0;i<tid %6;i++) tidString+="   ";
    tidString+="("+tid+")";
    return tidString;
   }
}