
package cw.platf;
import cw.log.Log;


/*
 * When this element is touching the user, it has the ability to 
 * -move the player 
 * -define a special handling when the user press fire
 */
public class GameElementMover extends GameElement {

	
   	
 // define the deltas for deciding when the element and the player are touching	
  int mDX1=0;
  int mDY1=0;
  int mDX2=0;
  int mDY2=0;	
	
  boolean mMover; // should we move the player according to this element movement
 
  boolean mFirable; // should special handling be done on fire
  int mWay; // fire taken in account on which way (0 means both)

  
  /*
   * Constructor for mover only element
   */
  GameElementMover(Platf pGM,String pName,int pX,int pY,int pImage)
  {
    super(pGM,pName,pX,pY,pImage);
    mIsTouchable=true;
    mIsKillable=false;
    mFirable=false;
    mMover=true;
    mDX1=5;
    mDY1=14;
    mDX2=mSizeX+0;
    mDY2=mSizeY-5;
  }
  
  /*
   * Constructor for firable only element
   */
  
  GameElementMover(Platf pGM,String pName,int pX,int pY,int pImage,int pWay)
  {
    super(pGM,pName,pX,pY,pImage);
    mIsTouchable=true;
    mIsKillable=false;
    mFirable=true;
    mMover=false;
    mWay=pWay;
    mDX1=5;
    mDY1=10;
    mDX2=mSizeX;
    mDY2=mSizeY;
  }
  
  
  /*
   * redefinition of element.manageTouchable(). 
   */
  public void manageTouchable()
  {  
	if(mGM.mPlayer!=null)
    {
	  
      boolean touching= ((mGM.mPlayer.mX+mDX1>mX) && (mGM.mPlayer.mX<mX+mDX2) &&
      (mGM.mPlayer.mY+mDY1>mY) && (mGM.mPlayer.mY<mY+mDY2));
      
      if (touching)
      {
        touched();
      }
    }
  }
  
  /*
   * called by manageTouchable when this element touches the player 
   */
  public void touched()
  {
  	//Nog.msg('D',"touched()");
  
  	mGM.mPlayer.mTouchingFlag=true; 
  
  	if (mMover)
  	{
      mGM.mPlayer.mMovingX=mDeltaX;
      mGM.mPlayer.mMovingY=mDeltaY;
      mGM.mPlayer.mMovingElement=this;
  	}
  	
    if (mFirable) 
    {
    	if (mWay==0)
    	{
    	  mGM.mPlayer.mFirableElement=this;
    	}
    	else if (mGM.mPlayer.mWay==mWay)
    	{
    	  mGM.mPlayer.mFirableElement=this;
    	}
    	
    }
  }
  
  /*
   * called by player when the user hits fire
   */
  public void onFire()
  {
  	//Nog.msg('D',"onFire()");
  }

  
}
