 // GamePlayer.java
//-----------

package cw.platf;
import cw.GI.*;
import cw.log.Log;

/**
 * this is the player 's game element 
 * 
 * 
 */
class GamePlayer extends GameElement
{
 
  
  /** the auto anim identifiers */
	
  public static final int AUTO_ANIM_QUIET_RIGHT=0;
  public static final int AUTO_ANIM_QUIET_LEFT=1;
  public static final int AUTO_ANIM_LEFT=2;
  public static final int AUTO_ANIM_RIGHT=3;
  public static final int AUTO_ANIM_JUMP_START_RIGHT=4;
  public static final int AUTO_ANIM_JUMP_START_LEFT=5;
  public static final int AUTO_ANIM_JUMP_RIGHT=6;
  public static final int AUTO_ANIM_JUMP_LEFT=7;
  public static final int AUTO_ANIM_HANG1=8;
  public static final int AUTO_ANIM_HANG2=9;
  public static final int AUTO_ANIM_FIRE_RIGHT=10;
  public static final int AUTO_ANIM_FIRE_LEFT=11;
  
  
  /* where is the guy looking at */
  public int mWay; 
  
  
  /* player's modes */
  public int mMainMode;
  public static final int MODE_STANDING=0;
  public static final int MODE_JUMPING=1;
  public static final int MODE_FALLING=2;
  public static final int MODE_HANGING=3;
  
  
  
  // used to represent users keys request 
  public int mKeyReqX=0;
  public int mKeyReqY=0;
  
  
  // special handling when a non venimous element is touching
  // the user
  public GameElementMover mMovingElement;
  public boolean mTouchingFlag=false;
  public int mMovingX;
  public int mMovingY;
  public GameElementMover mFirableElement;
  
  
  GamePlayer(Platf pGM)
  {
    
    super(pGM,"player",20,0,pGM.I_MAN_L_00);
    
    initAutoAnims(12);
    
    setAutoAnim(AUTO_ANIM_LEFT,
    new int[] {
      1,Platf.I_MAN_L_01,
      1,Platf.I_MAN_L_02,
      -1});
     setAutoAnim(AUTO_ANIM_RIGHT,
    new int[] {
      1,Platf.I_MAN_R_01,
      1,Platf.I_MAN_R_02,
      -1});  
      
      
      
    setAutoAnim(AUTO_ANIM_QUIET_RIGHT,
    new int[] {
      -2,Platf.I_MAN_R_00});
      
    setAutoAnim(AUTO_ANIM_QUIET_LEFT,
    new int[] {
      -2,Platf.I_MAN_L_00}); 
      
   /* setAutoAnim(AUTO_ANIM_JUMP,
    new int[] {
      1,11,
      1,10,
      1,12,-1});  
     */ 
     setAutoAnim(AUTO_ANIM_JUMP_START_RIGHT,
     new int[] {
      -2,Platf.I_MAN_R_03});    
      
     setAutoAnim(AUTO_ANIM_JUMP_START_LEFT,
     new int[] {
      -2,Platf.I_MAN_L_03});    
     
     setAutoAnim(AUTO_ANIM_JUMP_RIGHT,
     new int[] {
      -2,Platf.I_MAN_R_01});    
      
     setAutoAnim(AUTO_ANIM_JUMP_LEFT,
     new int[] {
      -2,Platf.I_MAN_L_01});    
      
      setAutoAnim(AUTO_ANIM_HANG1,
     new int[] {
      -2,Platf.I_MAN_R_04});    
      setAutoAnim(AUTO_ANIM_HANG2,
     new int[] {
      -2,Platf.I_MAN_L_04});   
      
      
       setAutoAnim(AUTO_ANIM_FIRE_RIGHT,
    new int[] {
      1,Platf.I_MAN_R_03,
      -2,Platf.I_MAN_R_03});
      
    setAutoAnim(AUTO_ANIM_FIRE_LEFT,
    new int[] {
      1,Platf.I_MAN_L_03,
      -2,Platf.I_MAN_L_03}); 
      
      
    mMainMode=MODE_STANDING;
    
    mWay=+1;
    
    
    mIsTouchable=false;
    mIsKillable=false;
    
    
    mEnergy=20;
    mAxes=10;
    
    mMovingElement=null;
    mFirableElement=null;
    mTouchingFlag=false;
	
    
  }
  
  // warning: these variables overwrite the GameElement ones
  // it is a cheap optimisation
  public static final  int mSizeX=5;
  public static final  int mSizeY=10;
  
  public  static final int mSizeXdiv2=mSizeX/2;
  public   static final int mSizeYdiv2=mSizeY/2;;
  
  public   static final int mSizeXdiv4=mSizeX/4;
  public   static final int mSizeYdiv4=mSizeY/4;;
  
  public   static final int mSizeXx3div4=(mSizeX*3)/4;
  public   static final int mSizeYx3div4=(mSizeY*3)/4;
  
  
  public int mDelayedKeyReqX=0;
  public int mDelayedKeyReqXCnt=0; 
  public static final int DELAYED_KEYREQ_X_MAX=3;
  public static final int DELAYED_KEYREQ_X_MAX_JUMPING=5;
  
  
  public void manage()
  {
    
    //Nog.msg('I',"GamePlayer.manage() mMainMode=",mMainMode," mX=",mX," mY=",mY);
    

    if (mH.wasKeyPressed(mH.mKeyCodeD)) 
    {
      mGM.startPause();    
    }
    
    // update movement request variables 
    
    mKeyReqX=0;
    mKeyReqY=0;
    if (mH.isKeyPressed(mH.mKeyCodeUpLeft   )) {mKeyReqX=-1;mKeyReqY=-1;}
    if (mH.isKeyPressed(mH.mKeyCodeUp       )) {            mKeyReqY=-1;}
    if (mH.isKeyPressed(mH.mKeyCodeUpRight  )) {mKeyReqX=+1;mKeyReqY=-1;}
    if (mH.isKeyPressed(mH.mKeyCodeLeft     )) {mKeyReqX=-1;            }
     
    if (mH.isKeyPressed(mH.mKeyCodeRight    )) {mKeyReqX=+1;            }
    if (mH.isKeyPressed(mH.mKeyCodeDownLeft )) {mKeyReqX=-1;mKeyReqY=+1;}
    if (mH.isKeyPressed(mH.mKeyCodeDown     )) {            mKeyReqY=+1;}
    if (mH.isKeyPressed(mH.mKeyCodeDownRight)) {mKeyReqX=+1;mKeyReqY=+1;}
    
    
    //Nog.msg('D',"mDelayedKeyReqX=",mDelayedKeyReqX);
	
    //Nog.msg('D',"mKeyReqX=",mKeyReqX," mKeyReqY=",mKeyReqY);
    
    
    if (mKeyReqX==0)
    {
    	if (mDelayedKeyReqXCnt!=0)
    	{
    		mDelayedKeyReqXCnt--;
    		mKeyReqX=mDelayedKeyReqX;
    	}
    }
    else
    {
    	mDelayedKeyReqXCnt=DELAYED_KEYREQ_X_MAX;
    	mDelayedKeyReqX=mKeyReqX;
    }
    //Nog.msg('D',"mMainMode=",mMainMode);
	  
    
     //Nog.msg('D',"mTouchingFlag=",mTouchingFlag);
     //Nog.msg('D',"mMovingElement=",mMovingElement);
     //Nog.msg('D',"mFirableElement=",mFirableElement);
    
     // movement variables
     
    mDeltaX=0;
    mDeltaY=0;
    
    
    // now treat according to mode
    switch (mMainMode)
    {
    
      case MODE_STANDING:
        manageStandingMode();
        break;
      case MODE_JUMPING:
       manageJumpingMode();
        break;
      case MODE_FALLING:
        manageFallingMode();
        break;
      case MODE_HANGING:
        manageHangingMode();
        break;  
      default:
      throw new RuntimeException("unkown mode for player:"+mMainMode);
    }
    
      
    manageEnergy();  
    
    
    // check if we are beeing moved by antoher game element
    if (mTouchingFlag==true)
	{
    	
    	
      if (mMainMode!=MODE_HANGING) // ignore this movement if we are hanging
      {
	    mDeltaX+=mMovingX;
	    mDeltaY+=mMovingY;
	  
	    mMovingX=0;
	    mMovingY=0;
      }
      
      // reset external movement variables
	  mTouchingFlag=false;
      mMovingElement=null;
      
      mFirableElement=null; // TODO: is this line required here?
      
      checkDeltaIsFine();
	}
    
    
    // last but not least! do move the player.
      
     mX+=mDeltaX;
     mY+=mDeltaY;
  }
  
  //--+ standing +-------------------------------------------------
  
  
  
  
  public void startStand()
  {
      mMainMode=MODE_STANDING;
     
      if (mTouchingFlag && mMovingElement!=null)
      {
      	mY=mMovingElement.mY-mSizeY;
        //Nog.msg('I'," start stand(touching) mY=",mY);
        mMovingY=0; // cancel moving Y as we already adjusted mY with mTouchingElement.mY
      }
      else
      {
        int inWorldX=(mX+(mSizeXdiv2))/mGM.mTiledScreen.mTileSizeX;
        int inWorldY=(mY+(mSizeYdiv2))/mGM.mTiledScreen.mTileSizeY;
        //Nog.msg('I',"start stand  inWorldX=",inWorldX," inWorldY=",inWorldY," mY=",mY);
        mY=(inWorldY)*mGM.mTiledScreen.mTileSizeY;
        //Nog.msg('I'," mGM.mTiledScreen.mTileY=",mGM.mTiledScreen.mTileSizeY," changed mY=",mY);
      }
      
      
      
      mDeltaY=0;
      
      
      
      mAnimMode=mWay>0?AUTO_ANIM_JUMP_START_RIGHT:AUTO_ANIM_JUMP_START_LEFT;
      processAutoAnim();
      
  }
  
  public void manageStandingMode()
  {
  
    boolean firing=false;
    //Nog.msg('D',"in Standing Mode");
    
    
    if (mH.wasKeyPressed(mH.mKeyCodeFire)) 
    {
      mAnimMode=mWay>0?AUTO_ANIM_FIRE_RIGHT:AUTO_ANIM_FIRE_LEFT;
      fire();
      firing=true;
    }
  
    
    
    if ( (!isThereGroundOrScale(mSizeXdiv4,mSizeY) && !isThereGroundOrScale(mSizeXx3div4,mSizeY))
    		&& startFall())
    {
      // nothing to do here. startFall() already did the jobe
    }
    else
    {
    
      
      if (firing==false) mAnimMode=mWay>0?AUTO_ANIM_QUIET_RIGHT:AUTO_ANIM_QUIET_LEFT;
    
      if (mKeyReqY==+1) 
      {
        if (isThereScale(mSizeXdiv4,mSizeY) || isThereScale(mSizeXx3div4,mSizeY))
        {
          mDeltaY=2;
          startHang();
        }
      }
      else if (mKeyReqY==-1) 
      {
      
        if (!isThereScale(mSizeXdiv4,mSizeYdiv4) && !isThereScale(mSizeXx3div4,mSizeYdiv4))
        { 
   
          startJump();
        }
        else
        {
          startHang();
        }
        
      }
      else if (mKeyReqX==+1) 
      {
      	 if (mDelayedKeyReqXCnt!=DELAYED_KEYREQ_X_MAX) mDeltaX=1;
      	 else mDeltaX=2;
         mAnimMode=AUTO_ANIM_RIGHT;
         mWay=+1;
      }
      else if (mKeyReqX==-1) 
      {
        if (mDelayedKeyReqXCnt!=DELAYED_KEYREQ_X_MAX) mDeltaX=-1;
      	else mDeltaX=-2;
        mWay=-1;
        mAnimMode=AUTO_ANIM_LEFT;
      }
    }
    
    checkDeltaIsFine();
    
    processAutoAnim();
  }
  
  
  
  
  //--+ jumping +------------------------------------------------
    
  
 // DeltaY increment during jump time
  public final static int JumpingDeltas[]={0,5,5,4,3,3,2,2,2};
  
    
  int mJumpingWay=0;
  int mJumpingCnt=0;
    
  public void startJump()
  {
    //Nog.msg('D',"startJump()");
   
    mMainMode=MODE_JUMPING;
    mJumpingCnt=0;
    mJumpingWay=0;
    
    
  
    
    mAnimMode= mWay>0?AUTO_ANIM_JUMP_START_RIGHT:AUTO_ANIM_JUMP_START_LEFT;
    
    if (mKeyReqX==+1) 
    {
      mJumpingCnt=2;
      mJumpingWay=+1;
      mWay=+1;
    }
    else if (mKeyReqX==-1) 
    {
      mJumpingCnt=2;
      mJumpingWay=-1;
      mWay=-1;
    }
   
     
  }
  
  
  public void endJump()
  {
  	  mDeltaX=mJumpingWay;
      
      // this for keeping X movement while falling
      mDelayedKeyReqXCnt=DELAYED_KEYREQ_X_MAX_JUMPING;
      mDelayedKeyReqX=mJumpingWay;
      mKeyReqX=mJumpingWay;
      
      
      if (!startFall())
      {
      	startStand();
      }

  }
  
   /**
   * manage jumping mode.
   *
   * 
   *
   */
  public void manageJumpingMode()
  {
    
    if (mH.wasKeyPressed(mH.mKeyCodeFire)) 
    {
      fire();
    }
  
    
    // end of jump
    if (mJumpingCnt>8) 
    {
    	endJump();
    }
    else
    {
      
      
    // check if player pressed right arrow 
    if (mKeyReqX==+1) 
    {
      mDeltaX=1;
      mAnimMode=AUTO_ANIM_JUMP_RIGHT;
      mWay=+1;
    }
    // check if player pressed left arrow  
    else if (mKeyReqX==-1) 
    {
      mDeltaX=-1;
      mWay=-1;
      mAnimMode=AUTO_ANIM_JUMP_LEFT;
    }
    // otherwise same as previous key pressed  
    else
    {
      mDeltaX=mJumpingWay+mJumpingWay;
    }
         
         
      if (mJumpingCnt>3)
      {
           
      if (mJumpingCnt==5 &&  mKeyReqY!=-1)
        {
          endJump();   
          
        }
        else
        {
          
          mDeltaY=-JumpingDeltas[mJumpingCnt];
        }
      }   
         
         
         
      
      
      else if (mJumpingCnt>1)  
      {
        mDeltaY=-JumpingDeltas[mJumpingCnt];;
        mDeltaX=mJumpingWay;
      }
      else if (mJumpingCnt==1) 
      {
        mAnimMode=mWay>0?AUTO_ANIM_JUMP_RIGHT:AUTO_ANIM_JUMP_LEFT;
      }
      
    }
    
    checkDeltaIsFine();
   
    
    mJumpingCnt++;
    processAutoAnim();
  }
  
  
 
  
  //--+ falling +----------------------------------------------
  
  
  
  int mFallingCnt;
  
  
  public boolean startFall()
  {
  	//Nog.msg('D',"startFall() mTouchingFlag=",mTouchingFlag);
     if (mTouchingFlag==true && mMovingElement!=null)
     {
       return false;
     }
     else
     {
       mMainMode=MODE_FALLING;
       mFallingCnt=0;
       return true;
     }
      
  }
  
  
  
   public void manageFallingMode()
  {
     //Nog.msg('D',"in falling mode");
     if (mH.wasKeyPressed(mH.mKeyCodeFire)) 
     {
       fire();
     }
   
    if (mKeyReqX==+1) 
    {
      mDeltaX=(mFallingCnt<3)?2:1;
      mAnimMode=AUTO_ANIM_JUMP_RIGHT;
      mWay=+1;
    }
    else if (mKeyReqX==-1) 
    {
      mDeltaX=(mFallingCnt<3)?-2:-1;
      mWay=-1;
      mAnimMode=AUTO_ANIM_JUMP_LEFT;
    }
    
    
  
    if (mFallingCnt<3) 
    {
      mDeltaY=2; 
    }
    else mDeltaY=5;       
    
    
    
    
    checkDeltaIsFine();
    
    
      
    
    if (isThereGroundOrTopScale(mSizeXdiv4+mDeltaX,mSizeY+mDeltaY)  || isThereGroundOrTopScale(mSizeXx3div4+mDeltaX,mSizeY+mDeltaY))
    {
      startStand();
    } 
    else if (mKeyReqY==-1 && (isThereScale(mSizeXdiv4+mDeltaX,mSizeYdiv4+mDeltaY)  || isThereScale(mSizeXx3div4+mDeltaX,mSizeYdiv4+mDeltaY)))
    {
      
      startHang();

    }
    else  if (mTouchingFlag==true && mMovingElement!=null)
     {
       startStand();
     }
    
    mFallingCnt++;
    
    
  }
    
   //--+ hanging +------------------------------------------------
   int mHangingCnt;
   
   public void startHang()
  
   {
    //Nog.msg('D',"startHang()");
   
    mMainMode=MODE_HANGING;
    mHangingCnt=0;
 
    
    mAnimMode= AUTO_ANIM_HANG1;
    
  }
  
  
  public void manageHangingMode()
  {
    
    boolean moved=false;
    
    if ( !isThereScale(mSizeXdiv4,mSizeY-1) && !isThereScale(mSizeXx3div4,mSizeY-1)
      && !isThereScale(mSizeXdiv4,0) && !isThereScale(mSizeXx3div4,0)
    )
    {
      
      startStand();
    }
    else
    {
      
      if (mKeyReqY==+1) 
      {
        mDeltaY++;
        moved=true;
        
        
      }
      else if (mKeyReqY==-1) 
      {
        mDeltaY--;
        moved=true;
      }
      if (mKeyReqX==+1) 
      {
        mDeltaX++;
        moved=true;
        mWay=+1;
      }
      else if (mKeyReqX==-1) 
      {
        mDeltaX--;
        moved=true;
        mWay=-1;
      }
    }
    
    if (moved) 
    {
      mHangingCnt++;
      if (mHangingCnt>1) mHangingCnt=0;
      mAnimMode=AUTO_ANIM_HANG1+mHangingCnt;
    }
    
    checkDeltaIsFine();
    processAutoAnim();
    
  }
  
  
  //--+ energy and axes stuff +---------------------------------------
  
  
   int mImuneCnt=0;
   int mNormalImage;
   int mEnergy;
   public boolean mFlashing=false;
   
  public void looseEnergy(int lostEnergy)
  {  
    if (mImuneCnt==0)
    {
      mEnergy-=lostEnergy;
      mImuneCnt=15;
    
      if (mEnergy<=0) mGM.gameOver();
      //mH.startFlash(5);  
      mNormalImage=mImage;
      startJump();
    }
  }
  
  public void earnEnergy(int earntEnergy)
  {
      mEnergy+=earntEnergy;
      if (mEnergy>20) mEnergy=20; 
  }
  
   public void earnAxes(int earntAxes)
  {
      mAxes+=earntAxes;
      if (mAxes>10) mAxes=10; 
  }


  
  public void manageEnergy()
  {
    if (mImuneCnt>0)
    {
        mImuneCnt--;
        if (mImuneCnt%2==1) 
        {
          if (mImage!=mGM.I_MAN_09) mNormalImage=mImage;   
          mImage=mGM.I_MAN_09;
          mFlashing=true;
        }
        else
        {
          mImage=mNormalImage;
          mFlashing=false;
        }
    }
  }
  
  //--+ axes stuff +-----------------------------
  
  
  
  int mAxes;
   
   
  
  
  public void fire()
  {
    if (mTouchingFlag && mFirableElement!=null)
    {
      mFirableElement.onFire();	
    }
    else if (mAxes>0)
    {
      mAxes--;
        
    
      GameElement elem=new GameElementAxe(mGM,"axe",mX+mWay,mY+mSizeYdiv2,mGM.I_AXE_00);
      elem.initAutoAnims(1);
      elem.setAutoAnim(0,
        new int[] {
        1,mGM.I_AXE_00,
        1,mGM.I_AXE_01,
        1,mGM.I_AXE_02,
        1,mGM.I_AXE_03,
        -1});
     
      
      elem.setScript(new Script(elem,new int[] {
        Script.SET_AANIM,0,
        Script.SET_DXY,8*mWay,-2,
        Script.DELAY,1,
        Script.SET_DXY,7*mWay,0, 
        Script.DELAY,1,
        Script.SET_DXY,6*mWay,3, 
        Script.DELAY,2,
        Script.SET_DXY,5*mWay,5, 
        Script.DELAY,25,
        Script.DIE,
        Script.END}));   
        
        
      elem.mIsTouchable=false; 
      
      mGM.addElement(elem);
    }
  }
  
  
  
  
  
  //--+ utils +-----------------------------------------------------


    public void checkDeltaIsFine()
    {
    	if (mDeltaX<0)
    	{
    		
    		if (isThereGround(0+mDeltaX,mSizeYdiv4+mDeltaY) || isThereGround(0+mDeltaX,mSizeYx3div4+mDeltaY))  mDeltaX=0;
    		
    		if (mX+mDeltaX-mGM.mScreenX<10)
    		{
    			
    			if (mX<2) mX=2;
    			else mGM.startScreenScroll(-3,0);
    			
    		}
    	}
    	else
    	if (mDeltaX>0)
    	{
    		
    		if (isThereGround(mSizeX+mDeltaX,mSizeYdiv4+mDeltaY) || isThereGround(mSizeX+mDeltaX,mSizeYx3div4+mDeltaY)) mDeltaX=0;
    		
    		if (mX+mDeltaX-mGM.mScreenX+mSizeX>mH.mMaxX-mSizeX)
    		{
    			
    			if (mX>mGM.mTiledScreen.mScreenSizeXxmTileSizeX-mSizeX) mX=mGM.mTiledScreen.mScreenSizeXxmTileSizeX-mSizeX;
				else mGM.startScreenScroll(3,0);
    			
    		}		
    	} 
    		
    	if (mDeltaY<0)
    	{
    		
    		if (isThereGround((mSizeX/2)+mDeltaX,-1)) 
    		{
    			mDeltaY=0;
    			startFall();
    		}
    		
    		//Nog.msg('F',"mY=",mY," mGM.mScreenY=",mGM.mScreenY," mH.mMaxY=",mH.mMaxY);
    		if (mY+mDeltaY-mGM.mScreenY<10)
    		{
    			if (mY<2) mY=2;
    			else mGM.startScreenScroll(0,-3);
    			
    			
    		}
    	} 
    	else  if (mDeltaY>0)
    	{
    		
    		if (isThereGround((mSizeXdiv2),mSizeYx3div4+mDeltaY)) 
    		{
    			mDeltaY=0;
    			startFall();
    		}
    		
    		
    		//Nog.msg('F',"mY=",mY," mGM.mScreenY=",mGM.mScreenY," mH.mMaxY=",mH.mMaxY);
    		if (mY+mDeltaY-mGM.mScreenY+mSizeY>mH.mMaxY-mSizeY)
    		{
    			if (mY>mGM.mTiledScreen.mScreenSizeYxmTileSizeY-mSizeY) 
    				{
    					mY=mGM.mTiledScreen.mScreenSizeYxmTileSizeY-mSizeY;
    					
    				
    					looseEnergy(mFallingOutOfScreenLostEnergy);
    					
    				}
				else mGM.startScreenScroll(0,3);
    			
    			
    		}
    	}
    }
    
    public static final int mFallingOutOfScreenLostEnergy=50;
	
    public void die()
    {
    	
    	createEjectAnim(this,-mWay);
    	requestDestroy();
    }
  
    
  
}


