// Platf.java
//-----------
/*
 * TODO list:
 *
 *  tile manager with buffer
 *
 *
 *  world concept. game elements generation
 *
 *
 *
 */
package cw.platf;
import cw.GI.*;
import cw.log.Log;





public class Platf extends GIGameMgr
{
	
	
	

	GamePlayer mPlayer;
  GameElement mElements[]=null;
  
  int mElementsSize;
  
  
  public void initGameElements()
  {
    // in case it is not the first call
    // properly remove the current elements
    if (mElements!=null) removeAll();
    
    mElementsSize=15;
    //Nog.msg('I',"initGameElements(",mElementsSize,")");
    
    mElements=new GameElement[mElementsSize];
    
    for (int i=0;i<mElementsSize;i++)
    {
      mElements[i]=null;
    }
    
  }
  
  /**
   * returns the first free index available.
   * after the slot 0, which is reserved for the player
   *
   * TODO remove this protection, the player should be accessed
   * through mPlayer and NOT through mElements[0]
   */
  public int getFreeIndex()
  {
    int retVal=-1;
    for (int i=1;i<mElementsSize;i++)
    {
      if (mElements[i]==null) 
      {        
        retVal=i;
        break;
      }
    }
    //Nog.msg('I',"getFreeIndex() return ",retVal);
    
    return retVal;
  }
  
  
  public int addElement(GameElement pElem)
  {
    return addElement(getFreeIndex(),pElem);
  }
  
  public int addElement(int index,GameElement pElem)
  {
   
    if (pElem.mName==null || pElem.mName.equals("")) pElem.mName="#"+index;
    //Nog.msg('I',"addElement(",index,",",pElem.mName,")");
    //Nog.msg('I'," x=",pElem.mX," y=",pElem.mY);
 
    if (mElements[index]!=null) throw new RuntimeException(" game element "+index+"not empty");
     
    mElements[index]=pElem;   
    return index; 
  }
  
  
  
  
  
  
  /**
   * removes the disposed game elements
   * also manages the mElementsMaxInUse
   */
  
  public void removeDestroyeds()
  {
    //Nog.msg('I',"removeDestroyeds()");
    
    for (int i=0;i<mElementsSize;i++)
    {
      GameElement elem=mElements[i];
      if (elem!=null)
      {
        if (elem.mDeadFlag)
        {
          //Nog.msg('I',"removeDestroyed() remove element "+elem.mName); 
          elem.done();
          mElements[i]=null;
        }
      }
    }
  }
  
  
  
  /**
   * removes all the game elements
  */
  
  public void removeAll()
  {
    //Nog.msg('I',"removeAll()");
    
    for (int i=0;i<mElementsSize;i++)
    {
      GameElement elem=mElements[i];
      if (elem!=null)
      {
          //Nog.msg('I',"removeAll() remove element "+elem.mName); 
          elem.done();
          mElements[i]=null;
      }
    }
    
    mPlayer=null;
    
    //DEBUG{
    Script.logStats();
    //DEBUG}
    
  }
  
  
  public void manageElements()
  {
    
    //Nog.msg('I',"manageElements() starts");
    
    for (int i=mElementsSize-1;i>=0;i--)
    {
      GameElement elem=mElements[i];
      if (elem!=null)
      {
          //Nog.msg('D',"");
          //Nog.msg('D',"manage(",elem.mName+i,") mX=",elem.mX," mY=",elem.mY);
   
          elem.manage();
        
      }
    }

    removeDestroyeds();
  }
  
  
  public void paintElements()
  {
    
   // //Nog.msg('I',"paintElements()");
    
    for (int i=mElementsSize-1;i>=0;i--)
    {
      GameElement elem=mElements[i];
      if (elem!=null)
      {
        elem.paint();
        
      }
    }
  }
	
	
  
	
 
	
	
	
	
	
	
	 
  GITiledScreen mTiledScreen;
  
  
  //--+ image identifiers +--------------------------------------------------------

  
  // raw stuff 
  public static final int I_NUM_00=0;
  public static final int I_BLUE =5;
  public static final int I_BLACK =6;
  public static final int I_WHITE =7;
  
  public static final int I_GRASS_00 =8;
  public static final int I_GRASS_01 =I_GRASS_00+1;
  
  
 
  
  
  // ground
  
  public static final int GROUND_START=20;
  public static final int I_GROUND_00 =20;
  public static final int I_GROUND_01 =I_GROUND_00+1;
  public static final int I_GROUND_02 =I_GROUND_00+2;
  public static final int I_GROUND_03 =I_GROUND_00+3;
  
  public static final int GROUND_END=29;
  
  
  public static final int SCALE_START=37;
  public static final int I_SCALE_00 =37;
  public static final int I_SCALE_01 =38;
  public static final int SCALE_END=38;
  
  
  // all the rest is considered as transparent
  public static final int I_BORDER_R_00 = 40;
  public static final int I_BORDER_L_00 = 41;
  public static final int I_BORDER_01 = 42;
  
  
  
  
 
   // player images
  public static final int I_MAN_R_00 =100;
  public static final int I_MAN_R_01 =I_MAN_R_00+1;
  public static final int I_MAN_R_02 =I_MAN_R_00+2;
  public static final int I_MAN_R_03 =I_MAN_R_00+3;
  public static final int I_MAN_R_04 =I_MAN_R_00+4;
 
      
  public static final int I_MAN_L_00 =105;
  public static final int I_MAN_L_01 =I_MAN_L_00+1;
  public static final int I_MAN_L_02 =I_MAN_L_00+2;
  public static final int I_MAN_L_03 =I_MAN_L_00+3;
  public static final int I_MAN_L_04 =I_MAN_L_00+4;
  
  public static final int I_MAN_09 =110;

  public static final int I_AXE_00 =120;
  public static final int I_AXE_01 =I_AXE_00+1;
  public static final int I_AXE_02 =I_AXE_00+2;
  public static final int I_AXE_03 =I_AXE_00+3;
  
  
  
  // bad guys
  
  public static final int I_BAD_A_00 =130;
  public static final int I_BAD_A_01 =I_BAD_A_00+1;
  public static final int I_BAD_A_02 =I_BAD_A_00+2;
  
  public static final int I_BAD_B_R_00 =135;
  public static final int I_BAD_B_R_01 =I_BAD_B_R_00+1;
  
  public static final int I_BAD_B_L_00 =137;
  public static final int I_BAD_B_L_01 =I_BAD_B_L_00+1;

  
  public static final int I_BAD_C_R_00 =139;
  public static final int I_BAD_C_R_01 =I_BAD_C_R_00+1;
  
  public static final int I_BAD_C_L_00 =141;
  public static final int I_BAD_C_L_01 =I_BAD_C_L_00+1;

  
  // other elements
  public static final int I_TRUNK_00=170;
  public static final int I_SWITCH_ON=180;
  public static final int I_SWITCH_OFF=181;
  
  
  public static final int I_BONUS_00=182;
  public static final int I_BONUS_01=I_BONUS_00+1;
  
  
  
  // 90 is reserved for the tiledscreen buffer
  
  // text stuff
  public static final int I_GAMEOVER =93;
  public static final int I_PLAY_QUIT =91;
  public static final int I_RESUME_QUIT=92;
  
  
  
  public void initImages(int step) 
  {
    
  	
  	
  	 switch (step)
	{
    	case INIT_IMG_1:
    		 mH.loadImages(I_NUM_00,5,"num",".png");
    
    		break;
    	case INIT_IMG_2:
    		 mH.loadImage(I_BLUE,"blue",".png");
    mH.loadImage(I_BLACK,"black",".png");
    mH.loadImage(I_WHITE,"white",".png");
    
    mH.loadImages(I_GRASS_00,2,"grass",".png");
    mH.loadImage(I_BORDER_L_00,"border00l",".png");
    mH.loadImage(I_BORDER_R_00,"border00r",".png");
    mH.loadImage(I_BORDER_01,"border01",".png");
    
    
    		break;
    	case INIT_IMG_3:
    		 mH.loadImages(I_MAN_R_00,5,"man","r.png");
    mH.loadImages(I_MAN_L_00,5,"man","l.png"); 
    
    mH.loadImage(I_MAN_09,"man09",".png"); 
    //mH.loadImage(13,"man03",".png",false);
    
     mH.loadImages(I_AXE_00,4,"axe",".png");
  
   
    		break;
    	case INIT_IMG_4:
    		 mH.loadImages(I_GROUND_00,4,"ground",".png");
    
    
    mH.loadImages(I_BAD_A_00,3,"bada","u.png");
   

    mH.loadImages(I_BONUS_00,2,"bonus","u.png");
    
    mH.loadImages(I_SCALE_00,2,"scale",".png");
    
    mH.loadImages(I_BAD_B_R_00,2,"badb","r.png");
    mH.loadImages(I_BAD_B_L_00,2,"badb","l.png");
    
    mH.loadImages(I_BAD_C_R_00,2,"snake","r.png");
    mH.loadImages(I_BAD_C_L_00,2,"snake","l.png");
    
    		break;
    	case INIT_IMG_5:
    		  mH.loadImage(I_PLAY_QUIT,"playquit",".png");
    mH.loadImage(I_GAMEOVER,"gameover",".png");
    mH.loadImage(I_RESUME_QUIT,"resumequit",".png");
    
    mH.loadImage(I_TRUNK_00,"trunk",".png");
    mH.loadImage(I_SWITCH_ON,"switchon",".png");
    mH.loadImage(I_SWITCH_OFF,"switchoff",".png");

    		break;
	}		
    		
    		
   
   
    
   
    
    
    
   
    
  
    
      
    
    
  }



   
  GameWorldMgr mWorldMgr;
  
  
  int mLastInitStep=-1;
   
  public boolean inited()
  {
  	return mLastInitStep==INIT_DONE;
  }
  
  public final static int INIT_IMG_1=10;
  public final static int INIT_IMG_2=20;
  public final static int INIT_IMG_3=30;
  public final static int INIT_IMG_4=40;
  public final static int INIT_IMG_5=50;
  
  public final static int INIT_LOAD_WORLD=60;
  public final static int INIT_START_WORLD=70;

  
  
  public final static int INIT_DONE=90;
  
  
  

  public void init(int step)
  {
 
    //Nog.msg('D',"Platf.init() ");
   
    /*mTiledScreen=new GITiledScreen();
    mTiledScreen.setSize(10,16,10,10);
    mTiledScreen.init(mH,90);
    mTiledScreen.mClearTile=6;
    */
    switch (step)
	{
    	case INIT_IMG_1:
    	case INIT_IMG_2:
    	case INIT_IMG_3:
    	case INIT_IMG_4:
    	case INIT_IMG_5:
    		initImages(step);
    		break;
    	case INIT_LOAD_WORLD:
    		 mWorldMgr=new GameWorldMgr(this);
    		 mWorldMgr.loadWorldIntro();
    		 break;
    	case INIT_START_WORLD:
    		 mWorldMgr.startWorld(); 
    		
    		break;
    		
	}
     mLastInitStep=step;
    /*
    buildWorld1();
    */
    
   
   
  }
  
  
  
  
  public void done()
  {
    //Nog.msg('D',"Platf.done() ");
   
    removeAll();
    mTiledScreen=null;
    mWorldMgr.done();
    mWorldMgr=null;
    
  }
  
  
  
  /*
  
  public void buildWorld1()
  {
    
    
       int x[]={
    21, 5, 5, 5, 5, 5, 5, 5, 5,20, 
      5, 5, 5, 5, 5, 5,21, 5, 5,20, 
     21, 5, 5, 5, 5,21,20, 5, 5,20, 
      5, 5, 5,21, 5, 5, 5, 5, 5,20, 
     21, 5, 5, 5,38,21,38,21, 5,20, 
     21,21, 5, 5,37,20, 5, 5, 5,20, 
     21,21, 5, 5,37,21,22,22, 5,20,
     20,20,21,21,38,20,22,22, 5,20,
     21, 5, 5, 5, 5, 5, 5, 5, 5,20, 
      5, 5, 5, 5,20, 5,21, 5,20,20, 
     21, 5, 5, 5, 5, 5, 5, 5, 5,20, 
      5, 5, 5,21, 5,21, 5, 5, 5,20, 
     21, 5, 5, 5, 5,21, 5,21, 5,20, 
     21,21, 5, 5, 5,20,21, 5, 5,20, 
     21,21, 5, 5,21,21,21,21,21,20,
     20,20,21,21,20,20,20,20,20,20   
      };
    
    mTiledScreen.setTiles(x);
    
    initGameElements();
    
    
    
    
    addElement(mPlayer=new GamePlayer(this));
    
    
    {
      GameElement elem=new GameElement(this,"bad",70,30,I_BAD_A_02);
      elem.setScript(new Script(elem,new int[] {
        Script.SET_TOUCHABLE,0,
        Script.SET_IMG,I_BAD_A_02,
        Script.DELAY,50,
        
        Script.SET_TOUCHABLE,1,
        Script.SET_IMG,I_BAD_A_01,
        Script.DELAY,6,
        Script.SET_IMG,I_BAD_A_00,
        Script.DELAY,6,
        Script.SET_IMG,I_BAD_A_01,
        Script.DELAY,6,
        Script.SET_IMG,I_BAD_A_00,
        Script.DELAY,6,
        
        
        Script.GOTO,0,
        Script.END}));   
        
      elem.mDirectDraw=true;
      addElement(elem);
    }
    
    {
      GameElement elem=new GameElement(this,"bonus",40,120,I_BONUS_00);
      elem.setScript(new Script(elem,new int[] {
       
        Script.SET_IMG,I_BONUS_00,
         Script.DELAY,4,
        Script.SET_IMG,I_BONUS_01,
        Script.DELAY,4,
        Script.GOTO,0,
        Script.END}));   
        
      elem.setBonus(5,0,0);
  
      elem.mIsKillable=false;
      
      elem.mDirectDraw=true;
      addElement(elem);
      
    }
    {
      
        GameElement elem=new GameElement(this,"bonus",60,120,I_AXE_01);
      elem.setScript(new Script(elem,new int[] {
       
        Script.SET_IMG,I_AXE_00,
        Script.DELAY,4,
        Script.SET_IMG,I_AXE_03,
        Script.DELAY,4,
        Script.SET_IMG,I_AXE_02,
        Script.DELAY,4,
        Script.SET_IMG,I_AXE_01,
        Script.DELAY,4,
        Script.GOTO,0,
        Script.END}));   
        
      elem.setBonus(0,5,0);
  
      elem.mIsKillable=false;
      
      elem.mDirectDraw=true;
      addElement(elem);
      
      
    }
    
    
    
    
   
    
    
    {
      GameElement elem=new GameElement(this,"badb",20,60,I_BAD_B_R_00);
      elem.initAutoAnims(3);
      elem.setAutoAnim(0,
        new int[] {
        2,I_BAD_B_R_00,
        2,I_BAD_B_R_01,
        -1});
     
      elem.setAutoAnim(1,
        new int[] {
        2,I_BAD_B_L_00,
        2,I_BAD_B_L_01,
        -1});
        
      
      
      elem.setScript(new Script(elem,new int[] {
        Script.SET_AANIM,0,
        Script.SET_AMOVE,1,1,0,0,
        Script.DELAY,40,
        
        Script.SET_AANIM,1,
        Script.SET_AMOVE,1,-1,0,0,  
        Script.DELAY,40,
        
        Script.GOTO,0,
        Script.END}));   
        
        
       //elem.mIsTouchable=false; 
      addElement(elem);
    }
    
    
    
    
  
    
    
    
  
    
    
    
    
    
  }
  */
  
  //--+ screen scroll +------------------------------------------------------------ 
  int mScreenX=0;
  int mScreenY=0;
  
  
  
  
  
  public int mScreenMoveToX=0;
  public int mScreenMoveToY=0;
  public boolean mInScreenScroll=false;
  
  
  
  public void startScreenScroll(int dx,int dy)
  {
     //Nog.msg('D',"startScreenScroll(",dx,",",dy,") ");
    
  	
  	
  	
  	mScreenMoveToX=mScreenX+(dx*mTiledScreen.mTileSizeX);
    mScreenMoveToY=mScreenY+(dy*mTiledScreen.mTileSizeY);
    
    
    int mMaxScreenMoveX=mTiledScreen.mScreenSizeXxmTileSizeX-mH.mMaxX;
    if (mScreenMoveToX>mMaxScreenMoveX) mScreenMoveToX= mMaxScreenMoveX;
    
    int mMaxScreenMoveY=mTiledScreen.mScreenSizeYxmTileSizeY-mH.mMaxY;
    if (mScreenMoveToY>mMaxScreenMoveY) mScreenMoveToY= mMaxScreenMoveY;
      
    
    
    mInScreenScroll=true;
    
    
    
    
  }
  
  /**
   * manage the smooth screen scroll.
    */
  public void manageScreenScroll()
  {
     //Nog.msg('D',"manageScreenScroll() mScreenMoveToX= ",mScreenMoveToX," mScreenX=",mScreenX);
     //Nog.msg('D',"mScreenMoveToY= ",mScreenMoveToY," mScreenY=",mScreenY);
   
  
     int dx=0;
     int dy=0;
     
     int mScreenInTilesX=mTiledScreen.mViewSizeX;
     int mScreenInTilesY=mTiledScreen.mViewSizeY;
     
      
      if (mScreenMoveToX>mScreenX)
      {
      	
        dx=1;
        mWorldMgr.generateForTiles(mTiledScreen.mPosX+mScreenInTilesX,mTiledScreen.mPosY,1,mScreenInTilesY);
        
      
      }
      else if (mScreenMoveToX<mScreenX)
      {
        dx=-1;
        mWorldMgr.generateForTiles(mTiledScreen.mPosX-1,mTiledScreen.mPosY,1,mScreenInTilesY);
        
      }
      
      if (mScreenMoveToY>mScreenY)
      {
        dy=1;
        mWorldMgr.generateForTiles(mTiledScreen.mPosX,mTiledScreen.mPosY+mScreenInTilesY,mScreenInTilesX,1);
     
       
      }
      else if (mScreenMoveToY<mScreenY)
      {
        dy=-1;
        mWorldMgr.generateForTiles(mTiledScreen.mPosX,mTiledScreen.mPosY-1,mScreenInTilesX,1);
     
      }
    
      
      //Nog.msg('D',"dx=",dx," dy=",dy);
    
      if (dx==0 && dy==0)
      {
        //Nog.msg('D',"stoping screen scroll");
   
        mInScreenScroll=false;
       
      }
      else
      {
        mTiledScreen.move(dx,dy);
       // int screenDX=dx*mTiledScreen.mTileSizeX;
       // int screenDY=dy*mTiledScreen.mTileSizeY;
        mScreenX=mTiledScreen.mPosXxmTileSizeX;
        mScreenY=mTiledScreen.mPosYxmTileSizeY;
        
        
        
       
        
        updateInWindowCoords();
 
    
      }
    
  }
  
  
  //--+ in window stuff +------------------------------------------------------
  
  
  public int mInWindowX1;
  public int mInWindowY1;
  public int mInWindowX2;
  public int mInWindowY2;
  public int mInWindowDelta=20;
  
  
  /**
   *
   * This function updates the inWindow variables according to mScreenXY
   * variables.
   *
   * the inWindow variables are used to delimitate the window wherein
   * the game elements should remain alive.
   *
   * they are the game elements themselves which must check their position
   * against this window.
   *
   */
  public void updateInWindowCoords()
  {
     mInWindowX1=mScreenX-mInWindowDelta;
     mInWindowY1=mScreenY-mInWindowDelta;
     mInWindowX2=mScreenX+mH.mMaxX+mInWindowDelta;
     mInWindowY2=mScreenY+mH.mMaxY+mInWindowDelta;   
     
     //Nog.msg('I',"updateInWindowCoords()  x1=",mInWindowX1," y1=",mInWindowY1," x2=",mInWindowX2," y2=",mInWindowY2);
 
  }
  
  
  
  //--+ energy bar stuff +-----------------------------------------------------

 
  
  
  public void gameOver()
  {
    mPlayer.die();
    
    
    {
      GameElement elem=new GameElement(this,"msg",mH.mMaxX/2-20+mScreenX,mScreenY-10,I_GAMEOVER)
      {
        int mCnt=0;
        public void manage()
        {
          super.manage();
          
          mCnt++;
          if ((mCnt>20 && mH.wasKeyPressed(mH.mKeyCodeFire)) || mCnt>500) 
          {
            mGM.mWorldMgr.loadWorldIntro();
            mGM.mWorldMgr.startWorld();  
          }
        }
      };
      elem.setScript(new Script(elem,new int[] {
       
        
        Script.SET_DXY,0,1,
        Script.DELAY,mH.mMaxY/2,
        
        Script.SET_DXY,0,1,
        Script.DELAY,20,
        Script.SET_DXY,0,-1,
        Script.DELAY,20,
        
        Script.GOTO,5,
        Script.SET_DXY,0,0,
        
        Script.END})
       );   
        
   
      elem.mIsTouchable=false;
      addElement(elem);
      
    }
    
    
    
    
  }
  
  
  
  /**
   * Display a board with the current energy and
   * axes.
   * Currently just draw 2 lines on top of a black rectangle
   * The top line is the energy and the bottom one the axes.
   *
   * In addition the board may flash when the player is flashing too.
   */
  public void paintBoard()
  {
    
    // small fix to hide player when it is not defined
    // in a world. the problem is that when the player
    // die this will cause the board to disappear
    if (mPlayer==null) return;
     
    int color;
    int energy=0;
    int axes=0;
    int bgColor=mH.BLACK;
    
    if (mPlayer!=null) 
    {
      energy=mPlayer.mEnergy;
      axes=mPlayer.mAxes;
      bgColor=mPlayer.mFlashing?mH.WHITE:mH.BLACK;
    }
    
    
      if (energy>10) color=mH.GREEN;
      else if (energy>5) color=mH.YELLOW;
      else color=mH.RED;
    
      
      
      
      mH.printRect(2,2,23,8,bgColor,true);
      
      
      
      mH.printRect(3,3,2+energy,5,color,true);
      mH.printRect(3,6,2+axes*2,7,mH.GRAY,true);
    
  }
  
  
  
  //--+ step +----------------------------------------------------------
  
  
  //DEBUG{
  int mPrevStepLogCnt=0;
  //DEBUG}
  public void step(int clock)
  {
  
  	
    //Nog.msg('D',"");
    //Nog.msg('D',"");
    //Nog.msg('D',"-----------------------------------------");
    //Nog.msg('D',"");
    //Nog.msg('D',"");
    //Nog.msg('D',"step(",clock,") ");
    
    
    if (mPaused)
    {
      mPauseMenu.manage();
    }
    else
    {
      if (mInScreenScroll)
      {
        manageScreenScroll();
      }
      manageElements(); 
    }
    
    
     
     
     if (mH.isKeyPressed('O')) 
     {
         startScreenScroll(-1,0);
     }
     if (mH.isKeyPressed('P'))  
     {
         startScreenScroll(1,0);
     } 
     if (mH.isKeyPressed('Q')) 
     {
         startScreenScroll(0,1);
     }
     if (mH.isKeyPressed('A'))  
     {
         startScreenScroll(0,-1);
     }
     
    	 /*//DEBUG{
   int i=0;
  	while (Log.mCnt+i<mPrevStepLogCnt+55)
  	{
  		System.err.println("x");
  		i++;
  	}
  	mPrevStepLogCnt=Log.mCnt;
  	//DEBUG}*/
  }
  
  
  
  public void paint()
  {
  
    //Nog.msg('D',"Platf.paint() ");
    
    // mBackground.updateAndPaint();
    mTiledScreen.paint();
    
    paintElements();
    //for (int i=0;i<10;i++)
    // {
     //int d=mH.mThread.mClockCnt*2+i*2;
    // mH.printImage(d%mH.mMaxX,(d)%mH.mMaxY,3);
     //}
    //writeText(5,5,"hola "+mThread.mClockCnt,0x00FFF344,ROUNDED_FONT);
    //writeText(5,25,"background22 ",0x00FFF344,PLAIN_FONT);
    paintBoard();
    
  
  } 
  
  
       
  
  //--+ pause +-------------------------------------------------------------
  GameElement mPauseMenu;
  GameElement mPauseImage;
  boolean mPaused;
  
  public void startPause()
  {
    mPaused=true;
    
    
    mPauseImage=new GameElement(this,"resumequit",15+mScreenX,20+mScreenY,I_RESUME_QUIT);
    addElement(mPauseImage);
    mPauseImage.mIsTouchable=false;
   
    
    mPauseMenu=new GameElementMenu(this,"menu",5+mScreenX,20+mScreenY,2,10)
    {
      public void menuSelected(int pPos)
      {
        
        if (pPos==0)
        {
          mPauseImage.requestDestroy();
          mPauseMenu.requestDestroy();
          mPaused=false;
        }
        else
        {
          mGM.mWorldMgr.loadWorldIntro();
          mGM.mWorldMgr.startWorld();  
        }

      }
    };
    addElement(mPauseMenu);
    mPauseMenu.mIsTouchable=false;
   
    
  }
  
  public void stopPause()
  {
    mPaused=false;
    
  }
   

}
