// Script.java
//-----------

package cw.platf;
import cw.GI.*;
import cw.log.Log;


/*
 * 
 * @author bc
 *
 * TODO 
 * change the way delays are read. instead of standalone instruction,
 * put them ALWAYS after any instruction. should be a bit faster
 */
class Script 
{
  
  
  GameElement mE;
  Platf mGM;
  GIHarness mH;
  
  public  Script(GameElement e,int script[])
  {
    mE=e;
    mGM=e.mGM;
    mH=mGM.mH;
    setScript(script);
    //DEBUG{
    initStats();
    //DEBUG}
  }
  
  
  int mScript[];
  int mPos;
  boolean mDone;
  int mDelayCnt;
  
  public void setScript(int script[])
  {
    mPos=0;
    mScript=script; 
    mDone=false;
    mDelayCnt=0;
    //Nog.msg('D',"setScript() ",logScript());
  }  
  
  public final static int GOTO=-1;
  public final static int END=-2;
  public final static int DELAY=-3;
  public final static int DIE=-4;
   
  public final static int SET_IMG=-10;
  public final static int SET_TOUCHABLE=-11;
  public final static int SET_DXY=-12;
  public final static int SET_BONUS=-13;
  public final static int SET_DDRAW=-14;
  public final static int SET_AANIM=-15;
  public final static int SET_AMOVE=-16;
  public final static int STOP_AMOVE=-17;
  public final static int END_WORLD=-18;
  public final static int GOTO_XY=-19;
  
  
  
  
  
  
 
  
  
  
  
  public final static int TRUE=1;
  public final static int FALSE=0;
  
  
  public final static String codeNames[]=
  { 
  "",     // 0
  "GOTO", // 1
  "END",  // 2
  "DELAY",// 3
  "DIE",// 4
  "", // 5
  "", // 6
  "", // 7
  "", // 8
  "", // 9
  
  "SET_IMG", // 10
  "SET_TOUCHABLE",// 11
  "SET_DXY",// 12
  "SET_BONUS", // 13
  "SET_DDRAW", // 14
  "SET_AANIM", // 15
  "SET_AMOVE", // 16
  "STOP_AMOVE", // 17
  "END_WORLD", // 18
  "GOTO_XY", // 19
  
  "", // 20
  "", // 21
  "", // 22
  
  ""};
  
  
  public final static int codeLength[]=
  { 
  -1,// 0
  1,// 1
  0,// 2
  1,// 3
  0, // 4
  0, // 5
  0, // 6
  0, // 7
  0, // 8
  0, // 9
  
  1,// 10
  1, // 11
  2, // 12
  3, // 13 SET_BONUS
  1, // 14
  1, // 15 SET_AANIM
  4, // 16
  0, // 17 STOP_AMOVE
  0, // 18
  2, // 19 GOTO_XY
  
  0, // 20
  0, // 21
  0, // 22
  
  0};
  
  //DEBUG{
  public static int mStatUsage[];
  public static boolean mStatInited=false;
  
  public static void initStats()
  {
    if (mStatInited) return;
    
    mStatUsage=new int[64];
    for (int i=0;i<mStatUsage.length;i++)
    {
       mStatUsage[i]=0;       
    }
    mStatInited=true;
  }
  
  public static void logStats()
  {
    //Nog.msg('D',"logStats() for script usage"); 
    for (int i=0;i<mStatUsage.length;i++)
    {
       if (mStatUsage[i]!=0) 
       {
         //Nog.msg('D',"   code=",i," usage=",mStatUsage[i]);
       }
    }
  } 
  //DEBUG}
  //DEBUG{
  public String logScript()
  {
    return logScript(0,mScript.length);
  }
  
  
  public String logScript(int from,int to)
  {
    String retVal="";
    
    int cnt=from;
    
    do
    {
      int code=mScript[cnt];
      if ((code>=0) || (-code)>codeNames.length) throw new RuntimeException("invalid script code :"+code+" . up to here the script was:"+retVal);
      if (!retVal.equals("")) retVal+="\n";
      
      retVal=retVal+cnt+":"+codeNames[-code];
      cnt++;
      for (int i=0;i<codeLength[-code];i++)
      {
        retVal=retVal+" "+mScript[cnt];
        cnt++;
      }
     // //Nog.msg('D',"ret="+retVal);
      
    }
    while (cnt<to);
    return retVal;
    
  }
  //DEBUG}
  
  public void process()
  {
   
    ////Nog.msg('D',"process() mDelayCnt=",mDelayCnt," mDone=",mDone);
  	if (mDone) return;
    
    
    if ((--mDelayCnt)<0)
    {
      
      boolean keepReading=true;
      while (keepReading)
      {
        int code=mScript[mPos];
        //DEBUG{
        if(Log.doLog('D'))
		{
          //Nog.msg('D',"process() ",logScript(mPos,0));
		}
        // DEBUG}
        
        //DEBUG{
        mStatUsage[-code]++;
        //DEBUG}
        switch (code)
        {
          case DELAY:
            mDelayCnt=mScript[mPos+1];
            mPos+=2;
            keepReading=false;
            break;
  
          case SET_IMG:
            mE.mImage=mScript[mPos+1];
            mPos+=2;
            break;
          
          case SET_DXY:
            mE.mDeltaX=mScript[mPos+1];
            mE.mDeltaY=mScript[mPos+2];   
            mPos+=3;
            break;    
          
          case SET_AANIM:
            mE.mAutoAnim=true;  
            mE.mAnimMode=mScript[mPos+1];
            if (mE.mAnimMode>=mE.mAutoAnims.length || mE.mAutoAnims[mE.mAnimMode]==null) throw new RuntimeException("index "+mE.mAnimMode+" is not valid for SET_AANIM for element "+mE.mName);       
            
            mPos+=2;
            break;
            
           case SET_AMOVE:
            mE.initAutoMove(mScript[mPos+1],mScript[mPos+2],mScript[mPos+3],mScript[mPos+4]);
            mPos+=1+4;
            break;   
            
          case GOTO:
            mPos=mScript[mPos+1]; // return to beginning 
            break;
          
          case END: 
            mDone=true;
            keepReading=false;
            break;
          
         
          
  
          case DIE:
            mE.requestDestroy();
            mPos+=1;
            keepReading=false;
            break;   
          
           
           case SET_TOUCHABLE:
            mE.mIsTouchable=mScript[mPos+1]==TRUE;
            mPos+=2;
            break;  
            
            case SET_DDRAW:
            mE.mDirectDraw=mScript[mPos+1]==TRUE;
            mPos+=2;
            break;
            
            
           case SET_BONUS:
            mE.setBonus(mScript[mPos+1],mScript[mPos+2],mScript[mPos+3]);
            
            mPos+=5;
            break;    
            
                 
           
           
           case STOP_AMOVE:
            mE.mAutoMove=false;
            mPos+=1;
            break;
          
           case GOTO_XY:
           	mE.mDeltaX=0;
           	mE.mDeltaY=0;
            mE.mX=mScript[mPos+1];
            mE.mY=mScript[mPos+2];            
            mPos+=3;
            break;
              
          default:
            throw new RuntimeException(" unknown code "+code);
        }
      }
    }
  }
  
  /**
   * Destructor
   */
  public void done()
  {
    mE=null;
    mGM=null;
    
    
    mH=null;
    
    
  }
  
  
}
